/****************************************************************************
    $Id: csptmpl2.cpp 501.0 1995/03/07 12:26:12 RON Exp $

    Copyright (c) 1991-95 Tarma Software Research. All rights reserved.

    Project:	Tarma Library for C++ V5.0
    Author:	Ron van der Wal

    Instantiation of CSP templates; second part. The template instantiations
    are placed in separate files because of module size restrictions on the
    Macintosh (32k).

    $Log: csptmpl2.cpp $
    Revision 501.0  1995/03/07 12:26:12  RON
    Updated for TLX 5.01
    Revision 1.9  1995/01/31 16:30:08  RON
    Update for release 012
    Added partial support for SunPro C++ compiler
    Revision 1.8  1995/01/06  15:57:33  ron
    Corrected Revision keyword

    Revision 1.7  1994/11/16  15:38:10  ron
    Added module info; rearranged #include directives

    Revision 1.6  1994/10/10  16:48:58  ron
    Changed to <tlx\solve\csp.h>

    Revision 1.5  1994/09/28  14:16:47  ron
    Removed Macintosh-style #include references

    Revision 1.4  1994/09/27  20:22:10  ron
    Changed path separator from / to \

    Revision 1.3  1994/09/26  15:41:24  ron
    Changed include file references

    Revision 1.2  1994/09/06  20:27:38  ron
    Removed unused template instantiation pragmas

    Revision 1.1  1994/08/16  18:12:57  ron
    Initial revision

****************************************************************************/

#include <tlx\501\_build.h>

TLX_MODULE_INFO("$Revision: 501.0 $");

#include <tlx\501\solve\csp.h>

/*---------------------------------------------------------------------------
    Template source code

    Only for Symantec C++ for Macintosh currently; for other compilers
    the templatesa are instantiated in the usual source code files.
    On the Macintosh, this would result in segments larger than 32k.
---------------------------------------------------------------------------*/

#if defined(THINK_CPLUS)

    #include "seqbase.cpp"
    #include "vbase.cpp"

    #pragma template_access public

    #pragma template TLSeqBase<int>
    #pragma template TLVBase<int>

    #pragma template TLSeqBase<void *>
    #pragma template TLVBase<void *>

    #pragma template TLSeqBase<TLVariable *>
    #pragma template TLVBase<TLVariable *>

#endif
