/****************************************************************************
    $Id: subprobl.cpp 501.0 1995/03/07 12:26:24 RON Exp $

    Copyright (c) 1991-95 Tarma Software Research. All rights reserved.

    Project:	Tarma Library for C++ V5.0
    Author:	Ron van der Wal

    Implementation of classes TLProblemState and TLProblemInfo.

    $Log: subprobl.cpp $
    Revision 501.0  1995/03/07 12:26:24  RON
    Updated for TLX 5.01
    Revision 1.11  1995/02/22 12:23:08  RON
    Update for release 012
    Added partial support for SunPro C++ compiler
    Revision 1.10  1995/01/12  13:41:59  ron
    Adapted to previous Searcher/ProblemRep model

    Revision 1.9  1995/01/06  15:56:56  ron
    Adapted to new Searcher/Problem model

    Revision 1.8  1995/01/05  15:30:10  ron
    Naming changes

    Revision 1.7  1994/11/16  15:43:31  ron
    Added module info; rearranged #include directives

    Revision 1.6  1994/10/12  10:05:41  ron
    Added TLProblemInfo and related TLProblemState functions

    Revision 1.5  1994/10/10  16:55:16  ron
    Changed to <tlx\solve\searcher.h>

    Revision 1.4  1994/09/28  14:22:33  ron
    Removed Macintosh-style #include references

    Revision 1.3  1994/09/27  20:23:05  ron
    Changed path separator from / to \

    Revision 1.2  1994/09/26  15:47:54  ron
    Changed include file references

    Revision 1.1  1994/09/06  20:27:56  ron
    Initial revision

****************************************************************************/

#include <tlx\501\_build.h>

TLX_MODULE_INFO("$Revision: 501.0 $");

#include <tlx\501\solve\searcher.h>

/*-------------------------------------------------------------------------*/
    //TLProblemState::TLProblemState(TLProblemState *aParent)
    TLProblemState::TLProblemState()

/*  Constructor; links the subproblem to its parent (if any).
---------------------------------------------------------------------------*/
//: mParent(aParent)
{
  #ifdef _TLXDBG
    mIsProcessed = false;
  #endif
}

/*-------------------------------------------------------------------------*/
    TLProblemInfo *TLProblemState::GetInfo()

/*  Returns extra information about the problem. The default implementation
    returns 0.
---------------------------------------------------------------------------*/
{
    return 0;
}

/*-------------------------------------------------------------------------*/
    double TLProblemState::GetRank() const

/*  Returns the ranking of the node. In the default implementation, 0 is
    returned.
---------------------------------------------------------------------------*/
{
    return 0;
}

