/****************************************************************************
    $Id: zortech.h 501.0 1995/03/07 12:26:48 RON Exp $

    Copyright (c) 1991-95 Tarma Software Research. All rights reserved.

    Project:	Tarma Library for C++ V5.0
    Author:	Ron van der Wal

    Zortech-specific declarations of compilation and keyword-like names.

    $Log: zortech.h $
    Revision 501.0  1995/03/07 12:26:48  RON
    Updated for TLX 5.01
    Revision 1.5  1995/01/31 16:32:20  RON
    Update for release 012
    Added partial support for SunPro C++ compiler
    Revision 1.4  1994/11/16  15:24:20  ron
    Added _CCNAME, _CCVER, and _MODEL definitions

    Revision 1.3  1994/10/06  17:50:19  ron
    Added _NOMUTABLE

    Revision 1.2  1994/09/08  15:55:54  ron
    Moved O/S-specific macros into this file

    Revision 1.1  1994/08/16  18:06:58  ron
    Initial revision

****************************************************************************/

#ifndef _TLX_ZORTECH_H
#define _TLX_ZORTECH_H

#ifndef __ZTC__
#error This file is for Zortech compilations only
#endif

#define _CCNAME		Zortech C++
#define _CCVER		__ZTC__

#ifdef DLL
    #define _IN_DLL	1
#endif

#define _NORTTI		1
#define _NOEXCEPT	1
#define _NOBOOL		1
#define _NOMUTABLE	1

#ifdef OS2			/* Non-segmented platforms */

    #define _Near
    #define _Far
    #define _Huge
    #define _MODEL		Flat

    #define _ExportClass	_export
    #define _ExportFunc		_export
    #define _ExportData		_export

    #define _ImportClass
    #define _ImportFunc
    #define _ImportData

    #define OS_OS2      1
    #define _CPU_I86    1
    #define _LENDIAN    1
    #define _NULL_IS_0  1
    #define _MEM_FLAT   1

#else				/* Segmented memory architectures */

    #define _Near		_near
    #define _Far		_far
    #define _Huge		_huge

    #define _ExportClass	_export
    #define _ExportFunc		_export _far
    #define _ExportData		_export _far

    #define _ImportClass	_huge
    #define _ImportFunc		_far
    #define _ImportData		_far

    #if __TINY__ || __SMALL__
	#define _CODE_NEAR	1
	#define _DATA_NEAR	1
    	#define _MODEL		Tiny/Small
    #elif __COMPACT__
	#define _CODE_NEAR	1
	#define _DATA_FAR	1
    	#define _MODEL		Compact
    #elif __MEDIUM__
	#define _CODE_FAR	1
	#define _DATA_NEAR	1
    	#define _MODEL		Medium
    #elif __LARGE__ || __HUGE__
	#define _CODE_FAR	1
	#define _DATA_FAR	1
    	#define _MODEL		Large/Huge
    #endif

    #define _CPU_I86    1
    #define _LENDIAN    1
    #define _NULL_IS_0  1
    #define _MEM_SEG    1

    #if defined(WINDOWS)
    	#define OS_WIN16    1
    	#define OS_WINXXX   1
    #else
    	#define OS_DOS      1
    	#define OS_DOSXXX   1
    #endif
#endif

#endif	/* _TLX_ZORTECH_H */
